%% Funzione che calcola gli spostamenti in modalità triassiale per i Tilt Link
function [X_IPL,Y_IPL,Z_IPL,Xlocal_IPL,Ylocal_IPL,Zlocal_IPL,HShift_IPL,...
    HShift_local_IPL,AlfaX_IPL,AlfaY_IPL,Azimuth_IPL,Speed_local_IPL,...
    Speed_IPL,Acceleration_local_IPL,Acceleration_IPL,TempDef_IPL,...
    ARRAYdateIPL,ErrInPlaceLink,MAGdef_IPL] = triax_IPL(IDcentralina,...
    DTcatena,rIPL,ACCdef_IPL,ACCdefRis_IPL,MAGdef_IPL,TempDef_IPL,SpeIPL,PsIPL,...
    NodoInPlaceLink,tolleranzaAcc,tolleranzaMag,DatiElabInPlaceLink,...
    segnoNS,segnoEO,MEMS,Ndevst,Wdevst,ARRAYdateIPL,NuovoZeroIPL,Tmax,Tmin,...
    NdatiMedia,Ndatidespike,ErrInPlaceLink,Corr_Azimuth,margine,datainiIPL,FileName)
 
%% Inizializzazione
fileID = fopen(FileName,'a');
fmt = '%s \r';
text = 'triax_IPL function started';
fprintf(fileID,fmt,text);

if NuovoZeroIPL == 1
    if NdatiMedia > Ndatidespike
        Ndati = NdatiMedia;
    else
        Ndati = Ndatidespike;
    end
    ini = round(Ndati/2)+1;
    if rem(Ndati,2) == 0
        ini = ini+1;
    end
    clear NDati
    ini = ini + margine;
    if ini < 6
        ini = 6;
    end
    if Ndevst ~= 0 % Allora prendo tutti i dati e solo in seguito considero i nuovi, a valle della funzione filtro
        ini = 1;
    end
    ACCdefRis_IPL = ACCdefRis_IPL(ini:end,:);
    TempDef_IPL = TempDef_IPL(ini:end,:);
    DatiElabInPlaceLink = DatiElabInPlaceLink(ini:end,:);
    ARRAYdateIPL = ARRAYdateIPL(ini:end,1); 
    ErrInPlaceLink = ErrInPlaceLink(ini:end,:);
end

%% Controllo e correzione dei campi magnetici
[rA,cA] = size(ACCdef_IPL); % righe -> date, colonna -> nodi
conf_acc = zeros(rA,cA);
contM = 0; % contatore correzioni campi magnetici
contT = rA*cA;

% Se le accelerazioni variano meno della confidenza, NON cambio i valori di
% cambio magnetico e prendo quelli della lettura precedente
for d = 2:rA
    % seconda lettura e successive, confronto i risultati dei magnetometri
    % e degli accelerometri
    conf_acc(d,:) = abs(ACCdef_IPL(d,:) - ACCdef_IPL(d-1,:));
    for dd = 1:cA
        if abs(conf_acc(d,dd)) < tolleranzaMag  % SOGLIA ACCELERAZIONE
           MAGdef_IPL(d,dd) = MAGdef_IPL(d-1,dd);
           contM = contM+1;
        end
    end
end

text = ['' num2str(contM) ' corrections of magnetometers executed on a total amount of ' ...
    num2str(contT) ' data, which represent the ' num2str(contM*100/contT) '% for In Place Link'];
fprintf(fileID,fmt,text);

if NuovoZeroIPL == 1
    ACCdef_IPL = ACCdef_IPL(ini:end,:);
    MAGdef_IPL2 = MAGdef_IPL(ini:end,:);
else
    MAGdef_IPL2 = MAGdef_IPL;
end

%% Definisco i dati
Nnodi = rIPL;
[r,~] = size(ACCdef_IPL); % Numero di dati
[Ndati,~] = size(ARRAYdateIPL);
ax = zeros(r,Nnodi);
ay = zeros(r,Nnodi);
az = zeros(r,Nnodi);
mx = zeros(r,Nnodi);
my = zeros(r,Nnodi);
mz = zeros(r,Nnodi);
for i=1:Nnodi
    ax(:,i) = ACCdef_IPL(:,(i-1)*3+1); % ax
    ay(:,i) = ACCdef_IPL(:,(i-1)*3+2); % ay
    az(:,i) = ACCdef_IPL(:,(i-1)*3+3); % az
    mx(:,i) = MAGdef_IPL2(:,(i-1)*3+1); % mx
    my(:,i) = MAGdef_IPL2(:,(i-1)*3+2); % my
    mz(:,i) = MAGdef_IPL2(:,(i-1)*3+3); % mz
end

%% Costruzione delle matrici spostamento e rotazione
NordSud = zeros(Nnodi,Ndati); % in riga i nodi, in colonna le date
EstOvest = zeros(Nnodi,Ndati); % in riga i nodi, in colonna le date
Zlocal_IPL = zeros(Nnodi,Ndati);
 
% parametri per il calcolo
SpeIPL = SpeIPL(2:end,1); % salto il segmento di pertinenza dell'ancora
c = 1;

% Inizio del ciclo di elaborazione
text = 'Triaxial Elaboration of In Place Link started';
fprintf(fileID,fmt,text);

% Inizializzo le matrici
deltaNS = zeros(rIPL,1);
deltaEO = zeros(rIPL,1);
deltaZ = zeros(rIPL,1);
BECCHEGGIO = zeros(rIPL,1);
ROLLIO = zeros(rIPL,1);
IMBARDATA = zeros(rIPL,1);
qf = zeros(rIPL,4);
qfy = zeros(rIPL,4);
for jj = 1:Ndati
    for jjj=1:rIPL
        axb = ax(jj,jjj)';
        ayb = ay(jj,jjj)';
        azb = az(jj,jjj)';
        mxb = mx(jj,jjj)';
        myb = my(jj,jjj)';
        mzb = mz(jj,jjj)';
        SP = SpeIPL(jjj);
        [DNS,DEO,Dz,becc,roll,imba,q,qy] = QuaternioniASE(axb,ayb,azb,mxb,myb,mzb,SP,MEMS,FileName);
        deltaNS(jjj) = DNS;
        deltaEO(jjj) = DEO;
        deltaZ(jjj) = Dz;
        BECCHEGGIO(jjj) = becc;
        ROLLIO(jjj) = roll;
        IMBARDATA(jjj) = imba;
        qf(jjj,:) = q;
        qfy(jjj,:) = qy;
        dq = q-qy;
        if any(dq>0.000001)
            text = (['Cicle Number ' num2str(jj) ' during Quaternion Calculation']);
            text2 = (['Node Number ' num2str(jjj)]);
            fprintf(fileID,fmt,text);
            fprintf(fileID,fmt,text2);
        end     
    end
% Le seguenti matrici sono organizzate come segue:
% - ciascuna riga è relativa a un nodo (1a riga = fondo catena);
% - ciascuna colonna è relativa a una data.
   NordSud(:,c) = deltaNS;
   EstOvest(:,c) = deltaEO;
   Zlocal_IPL(:,c) = deltaZ;
   c = c+1;
end

% dNS e dEO raccolgono i dati del singolo nodo nella singola data
dNS = diff(NordSud,1,2);
dEO = diff(EstOvest,1,2);
dZ = diff(Zlocal_IPL,1,2);

%% Cambio di segno alle direzioni!
if segnoNS == 0
   dNS = -1*dNS;
end
if segnoEO == 0
   dEO = -1*dEO;
end
    
%% Controllo delle risultanti di accelerazione e campo magnetico
clear r
clear rr
clear c
clear cc
ACCdefRis_IPL = ACCdefRis_IPL';  % Nodi in riga, date in colonna
[r,c] = size(ACCdefRis_IPL);
[rr,cc] = size(NordSud);

% controllo che le matrici con le risultanti delle accelerazioni e 
% le matrici con i dati di spostamento abbiano le stesse dimensioni
if r~=rr
    text = '---Warning! Number of row of displacement data do not correspond to the number of acceleration cosine vector!---';
    fprintf(fileID,fmt,text);
end
if c~=cc
    text = '---Warning! Number of column of displacement data do not correspond to the number of acceleration cosine vector!---';
    fprintf(fileID,fmt,text);
end
clear i
clear j
cont = 1; % contatore
cont2 = 1; % contatore
cont3 = 1; % contatore
TempDef_IPL = TempDef_IPL';
textA = 'There are not correction of In Place Link based on acceleration vectors filter';
textA2 = 'There are not correction of In Place Link based on uncalibrated acceleration vectors';
textT = 'There are not correction of In Place Link based on temperature filter';
for j = 2:c % Data
    for i = 1:r % Nodo
        % se il valore assoluto della differenza è maggiore della
        % tolleranza, pongo gli spostamenti giornalieri pari a 0
        if abs(ACCdefRis_IPL(i,j)-ACCdefRis_IPL(i,j-1)) > tolleranzaAcc
            dNS(i,j-1) = 0;
            dEO(i,j-1) = 0;
            dZ(i,j-1) = 0;  
            textA = ['' num2str(cont) ' correction executed for In Place Link - Acceleration vector filter!'];
            cont = cont+1;
        end
        if strcmp(IDcentralina,'ID0115') == 1 
            if ACCdefRis_IPL(i,j) < 0.9 || ACCdefRis_IPL(i,j) > 1.17 % Il nodo è fuori taratura! 
            dNS(i,j-1) = 0;
            dEO(i,j-1) = 0;
            dZ(i,j-1) = 0;
            TempDef_IPL(i,j) = TempDef_IPL(i,j-1);
            textA2 = ['' num2str(cont) ' correction executed for In Place Link - uncalibrated Acceleration vector!'];
            cont3 = cont3+1;
            end
        else
            if ACCdefRis_IPL(i,j) < 0.9 || ACCdefRis_IPL(i,j) > 1.12 % Il nodo è fuori taratura!
                dNS(i,j-1) = 0;
                dEO(i,j-1) = 0;
                dZ(i,j-1) = 0;
                TempDef_IPL(i,j) = TempDef_IPL(i,j-1);
                textA2 = ['' num2str(cont) ' correction executed for In Place Link - uncalibrated Acceleration vector!'];
                cont3 = cont3+1;
            end
        end
    end
end

FileTemperature = ['' IDcentralina '-' DTcatena '-IPL-Therm.csv'];
if isfile(FileTemperature) == 1
    DatiRaw = csvread(FileTemperature);
    [rDR,cDR] = size(DatiRaw);
    DatiRaw(:,1) = DatiRaw(:,1) + 730000;
else
    rDR = 1;
    cDR = 1;
end
for b = 1:c % Data
    for a = 1:r % Nodo
        % NON considero i dati al di sopra dei 80 °C o al di sotto dei -30 °C! 
        if TempDef_IPL(a,b) > Tmax || TempDef_IPL(a,b) < Tmin
            cont2 = cont2+1;
            if b == 1
                if isfile(FileTemperature) == 1
                    RawDate = find(DatiRaw(:,1)<=datenum(datainiIPL));
                    if isempty(RawDate) == 1
                        cc = 2;
                        while cc <= c
                            if TempDef_IPL(a,cc) > Tmax || TempDef_IPL(a,cc) < Tmin
                                cc = cc+1;
                            else
                                break
                            end
                        end
                        TempDef_IPL(a,b) = TempDef_IPL(a,cc);
                    else
                        if isnan(DatiRaw(RawDate(end),a+1)) == 0
                            TempDef_IPL(a,b) = DatiRaw(RawDate(end),a+1);
                            ErrInPlaceLink(b,a) = 0.5;
                            wardat = 'Temperature data of In Place Link nodes corrected using Raw Data of reference Csv file.';
                            fprintf(fileID,fmt,wardat);
                        else
                            cc = 2;
                            while cc <= c
                                if TempDef_IPL(a,cc) > Tmax || TempDef_IPL(a,cc) < Tmin
                                    cc = cc+1;
                                else
                                    break
                                end
                            end
                            TempDef_IPL(a,b) = TempDef_IPL(a,cc);
                        end
                    end
                else
                    cc = 2;
                    while cc <= c
                        if TempDef_IPL(a,cc) > Tmax || TempDef_IPL(a,cc) < Tmin
                            cc = cc+1;
                        else
                            break
                        end
                    end
                    TempDef_IPL(a,b) = TempDef_IPL(a,cc);
                end
            else
                TempDef_IPL(a,b) = TempDef_IPL(a,b-1);
                dNS(a,b-1) = 0;
                dEO(a,b-1) = 0;
                dZ(a,b-1) = 0;
                ErrInPlaceLink(b,a) = 0.5;
            end
            textT = ['' num2str(cont2) ' correction executed for In Place Link - Temperature filter!'];
        end
    end
end

if  rDR~=1 && cDR~=1 && isempty(DatiRaw) == 0
    RawDate1 = find(DatiRaw(:,1)<=ARRAYdateIPL(1));
    if isempty(RawDate1) == 1
        RawDate2 = 1;
    elseif RawDate1(end) == rDR
        RawDate2 = find(ARRAYdateIPL(:,1)>DatiRaw(end,1));
    else
        RawDate2 = find(ARRAYdateIPL(:,1)>DatiRaw(RawDate1(end)+1,1));
    end
else
    RawDate1 = [];
    RawDate2 = 1;
end
if isempty(RawDate1) == 0 && isempty(RawDate2) == 0
    Dati = [DatiRaw(1:RawDate1(end),:); ARRAYdateIPL(RawDate2(1):end) TempDef_IPL(:,RawDate2(1):end)'];
elseif isempty(RawDate1) == 1 && isempty(RawDate2) == 0
    Dati = [ARRAYdateIPL TempDef_IPL'];
else
    Dati = DatiRaw;
end
% Elimino appoggio più vecchio di un mese
RawDate3 = find(Dati(:,1)<now-30);
if isempty(RawDate3) == 0
    [rDati,~] = size(Dati);
    if RawDate3(end) == rDati
    else
        Dati = Dati(RawDate3(end)+1:end,:);
    end
end
if isfile(FileTemperature) == 1
    delete(FileTemperature);
end
Dati(:,1) = Dati(:,1) - 730000;
csvwrite(FileTemperature,Dati);

TempDef_IPL = TempDef_IPL';

fprintf(fileID,fmt,textA);
fprintf(fileID,fmt,textA2);
fprintf(fileID,fmt,textT);
fclose(fileID);
            
% azzeramenti di alcuni nodi in particolare
[dNS,dEO,dZ] = azzeramenti(IDcentralina,DTcatena,dNS,dEO,dZ,NodoInPlaceLink,FileName);

% Filtro
[dNS,dEO,dZ] = filtro(dNS,dEO,dZ,Ndevst,Wdevst,FileName);
if NuovoZeroIPL == 1 && Ndevst ~= 0
    if NdatiMedia > Ndatidespike
        NdatiF = NdatiMedia;
    else
        NdatiF = Ndatidespike;
    end
    ini = round(NdatiF/2)+1;
    if rem(NdatiF,2) == 0
        ini = ini+1;
    end
    clear NDatiF
    iniST = round(Wdevst/2);
    if rem(Wdevst,2) == 0
        iniST = iniST+1;
    end
    iniST = iniST + margine;
    if iniST > ini
        ini = iniST;
    end
    if ini < 6
        ini = 6;
    end
    dNS = dNS(:,ini:end);
    dEO = dEO(:,ini:end);
    dZ = dZ(:,ini:end);
    TempDef_IPL = TempDef_IPL(ini:end,:);
    DatiElabInPlaceLink = DatiElabInPlaceLink(ini:end,:);
    ARRAYdateIPL = ARRAYdateIPL(ini:end,1); 
    ErrInPlaceLink = ErrInPlaceLink(ini:end,:);
end
    
%% Finalizzo i calcoli
[rNS,cNS] = size(dNS);
sommaX = zeros(rIPL,1);
Xlocal_IPL = zeros(rNS,cNS+1); % locale nello spazio, cumulato nel tempo
AlfaX_IPL = zeros(rNS,cNS+1); % Angoli
sommaY = zeros(rIPL,1);
Ylocal_IPL = zeros(rNS,cNS+1);
AlfaY_IPL = zeros(rNS,cNS+1); % Angoli
sommaZ = zeros(rNS,cNS);
Zlocal_IPL = zeros(rNS,cNS+1);
X_IPL = zeros(rNS,cNS+1); % cumulato nel tempo e nello spazio
Y_IPL = zeros(rNS,cNS+1); 
Z_IPL = zeros(rNS,cNS+1);
HShift_IPL = zeros(rNS,cNS+1); % massima pendenza cumulato nel tempo e nello spazio
HShift_local_IPL = zeros(rNS,cNS+1); % massima pendenza locale
Azimuth_IPL = zeros(rNS,cNS+1); % azimut
azim = zeros(rNS,cNS+1); % matrice di appoggio per il calcolo dell'azimuth
Speed_IPL = zeros(rIPL,cNS+1); % Velocità 2D Cumulata
Speed_local_IPL = zeros(rIPL,cNS+1); % Velocità 2D locale
Acceleration_IPL = zeros(rIPL,cNS+1); % Accelerazione 2D Cumulata
Acceleration_local_IPL = zeros(rIPL,cNS+1); % Accelerazione 2D Locale

% Recupero i dati già elaborati
if NuovoZeroIPL == 1
   [rE,cE] = size(DatiElabInPlaceLink);
   cont = 3;
   n = 1;
   while cont<=cE
         sommaX(n,1) = cell2mat(DatiElabInPlaceLink(1,cont))';
         Xlocal_IPL(n,1) = sommaX(n,1);
         X_IPL(n,1) = cell2mat(DatiElabInPlaceLink(1,cont+3))';
         sommaY(n,1) = cell2mat(DatiElabInPlaceLink(1,cont+1))';
         Ylocal_IPL(n,1) = sommaY(n,1);
         Y_IPL(n,1) = cell2mat(DatiElabInPlaceLink(1,cont+4))';
         for j = 1:rIPL
             AlfaX_IPL(j,1) = asind(Xlocal_IPL(j,1)/SpeIPL(j));
             AlfaY_IPL(j,1) = asind(Ylocal_IPL(j,1)/SpeIPL(j));
         end
         Zlocal_IPL(n,1) = cell2mat(DatiElabInPlaceLink(1,cont+2))';
         Z_IPL(n,1) = cell2mat(DatiElabInPlaceLink(1,cont+5))';
         HShift_IPL(n,1) = cell2mat(DatiElabInPlaceLink(1,cont+6))';
         HShift_local_IPL(n,1) = cell2mat(DatiElabInPlaceLink(1,cont+7))';
         Azimuth_IPL(n,1) = cell2mat(DatiElabInPlaceLink(1,cont+8))';
         Speed_IPL(n,1:rE) = cell2mat(DatiElabInPlaceLink(:,cont+10))';
         Speed_local_IPL(n,1:rE) = cell2mat(DatiElabInPlaceLink(:,cont+11))';
         Acceleration_IPL(n,1:rE) = cell2mat(DatiElabInPlaceLink(:,cont+12))';
         Acceleration_local_IPL(n,1:rE) = cell2mat(DatiElabInPlaceLink(:,cont+13))';
         cont=cont+16;
         n = n+1;
   end
else
    Zlocal_IPL(:,1) = SpeIPL;
    Z_IPL(:,1) = PsIPL(2:end);
end

% elaboro i dati nuovi
for iii = 1:cNS
    Xlocal_IPL(:,iii+1) = sum(dNS(:,1:iii),2)+sommaX(:,1);
    Ylocal_IPL(:,iii+1) = sum(dEO(:,1:iii),2)+sommaY(:,1);
    for j = 1:rIPL
        AlfaX_IPL(j,iii+1) = asind(Xlocal_IPL(j,iii+1)/SpeIPL(j));
        AlfaY_IPL(j,iii+1) = asind(Ylocal_IPL(j,iii+1)/SpeIPL(j));
    end
    sommaZ(:,iii+1) = sum(dZ(:,1:iii),2);
    X_IPL(:,iii+1) = cumsum(Xlocal_IPL(:,iii+1));
    Y_IPL(:,iii+1) = cumsum(Ylocal_IPL(:,iii+1));
    Z_IPL(:,iii+1) = cumsum(sommaZ(:,iii+1))+ Z_IPL(:,1);
    HShift_IPL(:,iii+1) = (X_IPL(:,iii+1).^2+Y_IPL(:,iii+1).^2).^0.5;
    HShift_local_IPL(:,iii+1) = (Xlocal_IPL(:,iii+1).^2+Ylocal_IPL(:,iii+1).^2).^0.5;
    Zlocal_IPL(:,iii+1) = sommaZ(:,iii+1) + SpeIPL; % Zeta è il singolo abbassamento di quel nodo
    for rr = 1:rIPL
        azim(rr,iii) = (acos(abs(X_IPL(rr,iii))/HShift_IPL(rr,iii)))*180/3.141592654; % Angolo Teta in gradi 0° - 90°
        segnoNS = sign(X_IPL(rr,iii));
        segnoEO = sign(Y_IPL(rr,iii));
        % L'azimuth si calcola con NS = 0, positivo in senso orario
        % (90° = Est)
        if segnoNS == 1 && segnoEO == 1 % quadrante 1
            Azimuth_IPL(rr,iii+1) = azim(rr,iii); % Teta lo tengo come è (1 quadrante)
        elseif segnoNS == -1 && segnoEO == 1 % quadrante 2
               Azimuth_IPL(rr,iii+1) = 180 - azim(rr,iii); % 180-teta
        elseif segnoNS == -1 && segnoEO == -1 % quadrante 3
               Azimuth_IPL(rr,iii+1) = 180 + azim(rr,iii); % 180+teta
        elseif segnoNS == 1 && segnoEO == -1 % quadrante 4
               Azimuth_IPL(rr,iii+1) = 360 - azim(rr,iii); % 360-teta
        elseif segnoNS == 0 && segnoEO == -1 % 270°
               Azimuth_IPL(rr,iii+1) = 270;
        elseif segnoNS == -1 && segnoEO == 0 % 180°
               Azimuth_IPL(rr,iii+1) = 180;
        end
    end
end
Azimuth_IPL = real(Azimuth_IPL);
Azimuth_IPL = Azimuth_IPL+Corr_Azimuth;
[rAz,cAz] = size(Azimuth_IPL);
for a = 1:rAz
    for b = 1:cAz
        if Azimuth_IPL(a,b) >= 360
           Azimuth_IPL(a,b) = Azimuth_IPL(a,b)-360;
        end
    end
end

%% Calcolo velocità di spostamento giornaliera
[numDate,~] = size(ARRAYdateIPL); % numero di date
d = 1;
p = 1;
diffDate = 0;
n = 1;
period = 1; % calcolo giornaliero
ContSUP = [];
for dd = 1:numDate
    while diffDate < period
          d = d+1;  
          if d > numDate % Se d supera le date disponibili, esco dal ciclo while
              break
          end
          diffDate = ARRAYdateIPL(d) - ARRAYdateIPL(p);
    end
    if d >numDate
        break
    end
    ContSUP(n,1) = d; %#ok<*AGROW> % Creo matrice indici dell'estremo superiore della differenza
    ContINF(n,1) = p; % Creo matrice indici dell'estremo inferiore della differenza
    p = p+1; % passo alla data di partenza successiva 
    d = p; % resetto il conto di d
    n = n+1;
    diffDate = 0;
end

check = isempty(ContSUP);
if check == 0
    [nDate,~] = size(ContSUP);
    for s = 1:rIPL
        N = 1;
        for dd = 1:nDate
            Speed_IPL(s,ContSUP(N,1)) = (HShift_IPL(s,ContSUP(N,1))-HShift_IPL(s,ContINF(N,1)))/(ARRAYdateIPL(ContSUP(N,1))-ARRAYdateIPL(ContINF(N,1)));
            Speed_local_IPL(s,ContSUP(N,1)) = (HShift_local_IPL(s,ContSUP(N,1))-HShift_local_IPL(s,ContINF(N,1)))/(ARRAYdateIPL(ContSUP(N,1))-ARRAYdateIPL(ContINF(N,1)));
            Acceleration_IPL(s,ContSUP(N,1)) = (Speed_IPL(s,ContSUP(N,1))-Speed_IPL(s,ContINF(N,1)))/(ARRAYdateIPL(ContSUP(N,1))-ARRAYdateIPL(ContINF(N,1)));
            Acceleration_local_IPL(s,ContSUP(N,1)) = (Speed_local_IPL(s,ContSUP(N,1))-Speed_local_IPL(s,ContINF(N,1)))/(ARRAYdateIPL(ContSUP(N,1))-ARRAYdateIPL(ContINF(N,1)));
            N = N+1;
        end
    end
end

% Approssimo i dati con il corretto numero di cifre decimali
[X_IPL,Y_IPL,Z_IPL,Xlocal_IPL,Ylocal_IPL,Zlocal_IPL,HShift_IPL,HShift_local_IPL,Azimuth_IPL,Speed_IPL,...
    Speed_local_IPL,Acceleration_IPL,Acceleration_local_IPL,TempDef_IPL] = approx(X_IPL,Y_IPL,Z_IPL,...
    Xlocal_IPL,Ylocal_IPL,Zlocal_IPL,HShift_IPL,HShift_local_IPL,Azimuth_IPL,Speed_IPL,Speed_local_IPL,...
    Acceleration_IPL,Acceleration_local_IPL,TempDef_IPL,FileName);

% Riordino matrice errori
[r,~] = size(ErrInPlaceLink);
Matrice_err = zeros(r,rIPL);
for i = 1:r % date
    d = 1;
    for n = 1:rIPL % nodi
        j = 1;
        err = ErrInPlaceLink(i,d:d+6);
        while j <= 7
            if err(1,j) == 1
                Matrice_err(i,n) = 1;
                break
            end
            if err(1,j) == 0.5
                Matrice_err(i,n) = 0.5;
            end
            j = j+1;
        end
        d = d+7;
    end
end
ErrInPlaceLink = Matrice_err';
    
text = 'In Place Link triaxial calculation executed correctly';
fileID = fopen(FileName,'a');
fmt = '%s \r';
fprintf(fileID,fmt,text);
fclose(fileID);

end